/*
 * SetAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _SET_ABSTRACTION_HPP_
#define _SET_ABSTRACTION_HPP_

#include <alib/memory>

#include <abstraction/AnyaryOperationAbstraction.hpp>

namespace abstraction {

template < class ParamType >
class SetAbstraction : public AnyaryOperationAbstraction < ext::set < ParamType >, ParamType > {
public:
	virtual bool run ( ) override {
		ext::set < ParamType > theSet;
		for ( const std::pair < std::shared_ptr < OperationAbstraction >, bool > & param : this->m_params ) {
			theSet.insert ( abstraction::retrieveValue < ParamType > ( param.first, param.second ) );
		}

		this->m_data = theSet;

		return true;
	}

};

} /* namespace abstraction */

#endif /* _SET_ABSTRACTION_HPP_ */
